package tests;


import models.BinaryBalance;

import org.junit.Assert;
import org.junit.Test;

/**
 * Unit tests for {@link BinaryBalance} which initialises the size of the weight 
 * set to {@link  JUnit_BinaryBalance#SIZE_OF_WEIGHT_SET}
 * @author gibson
 * @version 1
 */
public class JUnit_BinaryBalance extends JUnit_BalanceSpecification{
	
	static final int SIZE_OF_WEIGHT_SET = 20;
	
	 
	public void setUp() throws Exception {

		balanceUnderTest = new BinaryBalance(SIZE_OF_WEIGHT_SET);
	}
	
	
	/**
	 * A binary balance should be able to weigh all values between 1 and the maximum
	 */
    @Test
	public void testAllWeightsForRestrictedWeightSet (){
    	
    	int max = balanceUnderTest.maxThatCanBeWeighed();
    	
    	for (int i=1;i<=max;i++){
    		
    		balanceUnderTest.weigh(i);
    		Assert.assertEquals(i, balanceUnderTest.weighing());
    	}
	}
    

    
    @Test(expected=IllegalArgumentException.class)
    public void testOverflowOnMaximumWeight(){  	
    	new BinaryBalance (BinaryBalance.MAXIMUM_NUMBER_OF_BINARY_WEIGHTS+1);
    }
    
   
    @Test(expected=IllegalArgumentException.class)
    public void testNonNegativeWeightSet(){  	
    	new BinaryBalance (-1);
    }
    
    @Override
	public void testSomeRandomWeightsOnLargestSet (){
		
		balanceUnderTest = new BinaryBalance(BinaryBalance.MAXIMUM_NUMBER_OF_BINARY_WEIGHTS);
		super.testSomeRandomWeights();
	}

}
