package tests;

import models.TernaryBalance;

import org.junit.Assert;
import org.junit.Test;

/**
 * Unit tests for {@link TernaryBalance} which initialises the size of the weight 
 * set to {@link  JUnit_TernaryBalance#SIZE_OF_WEIGHT_SET}
 * @author gibson
 * @version 1
 */
public class JUnit_TernaryBalance extends JUnit_BalanceSpecification{
	
    static final int SIZE_OF_WEIGHT_SET = 15;
	
   
	public void setUp() throws Exception {

		balanceUnderTest = new TernaryBalance(SIZE_OF_WEIGHT_SET);
	}
	
	
	/**
	 * A ternary balance should be able to weigh all values between 1 and the maximum
	 */
    @Test
	public void testAllWeights (){
    	
    	int max = balanceUnderTest.maxThatCanBeWeighed();
    	
    	for (int i=1;i<=max;i++){
    		
    		balanceUnderTest.weigh(i);
    		Assert.assertEquals(i, balanceUnderTest.weighing());
    	}
	}
    
    @Test(expected=IllegalArgumentException.class)
    public void testOverflowOnMaximumWeight(){  	
    	new TernaryBalance (TernaryBalance.MAXIMUM_NUMBER_OF_TERNARY_WEIGHTS+1);
    }
    
   
    @Test(expected=IllegalArgumentException.class)
    public void testNonNegativeWeightSet(){  	
    	new TernaryBalance (-1);
    }


	@Override
	public void testSomeRandomWeightsOnLargestSet() {
		balanceUnderTest = new TernaryBalance(TernaryBalance.MAXIMUM_NUMBER_OF_TERNARY_WEIGHTS);
		super.testSomeRandomWeights();
		
	}

}
