package tools;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 
 * Simple utility code to provide a header for time stamping a program's execution with the provided String
 * 
 * @author J Paul Gibson
 * @version 1
 *
 */
public class DateHeader {

	/**
	 * 
	 * @return The current date and time when the method is executed.<br>
	 * Formatted as a 3 line string: <br>
	 * <tt>*******************************************************************<br>
           Execution Date/Time yyyy/mm/dd hh:mm:ss <br>
           ********************************************************************<br></tt>
	 */
	public  static String dateString(){
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		Date date = new java.util.Date();
		String str = "\n********************************************************************";
		str = str+"\nExecution Date/Time "+dateFormat.format(date);
		str = str + "\n*********************************************************************";
		return str;
	}
	
}
